.IFNDEF DESERVE_DEFINED
SET DESERVE_DEFINED = 1

  ! Identifies Driver Event Server
  SET DES.DRIVER.PRINTER    = 1

  ! Bit weighted features (each a power of 2)
  SET DES.FEATURE.SHUTDOWN  = 1
  SET DES.FEATURE.NEWPAGE   = 2
  SET DES.FEATURE.POSTCLOSE = 4
  SET DES.FEATURE.MESSAGE   = 8
  SET DES.FEATURE.5	    = 16

  ! Function number (1-32 coorespond to bits 0-31)
  SET DES.FUNCTION.INIT	    = 0
  SET DES.FUNCTION.SHUTDOWN = 1
  SET DES.FUNCTION.NEWPAGE  = 2
  SET DES.FUNCTION.POSTCLOSE = 3
  SET DES.FUNCTION.MESSAGE   = 4
  SET DES.FUNCTION.5	    = 5

! Printer Subtype 
!	00 = local printer 
!	01 = text printer
!	02 = HTML Printer
!	03 = PDF Printer
!	04 = windows printer
  SET DES.SUBTYPE.LOCAL		= 0
  SET DES.SUBTYPE.TEXT		= 1
  SET DES.SUBTYPE.HTML		= 2
  SET DES.SUBTYPE.PDF		= 3
  SET DES.SUBTYPE.WINDOWS	= 4
  

LENGTH 1 & LOCAL DES.DriverType$	! Identifies device driver
LENGTH 1 & LOCAL DES.Function$		! Function to be performed by server
LENGTH 8 & LOCAL DES.Program$		! Parent program in progress
LENGTH 3 & LOCAL DES.ProgDir$		! Parent program directory
LENGTH 2 & LOCAL DES.ProgramIP$		! Parent program IP address
LENGTH 1 & LOCAL DES.Lun$		! Device LUN
LENGTH 4 & LOCAL DES.Features$		! Available server features
LENGTH 1 & LOCAL DES.SubType$		! Additional driver data -- printer sub type
LENGTH 3 & LOCAL DES.RFU$		! Reserved for Future use
SET DES.USERDATA.SIZE = 64		! Available space for persistant user data
LENGTH DES.USERDATA.SIZE & LOCAL DES.UserData$	! Persistant User Data
LENGTH 254 & LOCAL DES.MsgData$		! one way data transfer buffer; driver <---> DES program

!========================================
! Prototype for server structure
!
! Up to DES.USERDATA_SIZE (64) bytes of
! persistant data may be added to the end.
!========================================
DES.Data: Format _	! Length
  DES.DriverType$; _ 	! 1
  DES.Function$; _ 	! 1
  DES.Program$; _  	! 8
  DES.ProgDir$; _  	! 3
  DES.ProgramIP$; _ 	! 2
  DES.Lun$; _  		! 1
  DES.Features$; _ 	! 4
  DES.SubType$; _ 	! 1
  DES.RFU$;_		! 3
  DES.UserData$;_ 	! Up to 64 bytes of user data
  DES.MsgData$		! one way data transfer driver <---> DES program

!====================
! Server entry example
!====================
!
!  ! Load driver info and persistant user data
!  Input (#, DES.Data)
!
!  Lun = ASC(DES.Lun$)
!  Function = ASC(DES.Function$)
!
!  Select Case Function
!
!    Case DES.FUNCTION.INIT
!      Gosub Init
!
!    Case DES.FUNCTION.SHUTDOWN
!      Gosub Shutdown
!
!    Case DES.FUNCTION.NEWPAGE
!      Gosub NewPage
!
!  EndSelect
!
!  ! Save driver info and persistant user data
!  Print (#, DES.Data)
!  Exit
!
!Init:
!  ! If not for this driver
!  If (ASC(DES.DriverType$) NE DES.DRIVER.PRINTER)
!    DES.Features$ = IntelD(0) ! clear ALL feature bits
!    Return   ! return
!  Endif
!
!  ! Tell driver what features we support
!  DES.Features$ = IntelD(DES.FEATURE.SHUTDOWN+DES.FEATURE.NEWPAGE)
!Return
!
!Shutdown:
!Return
!
!NewPage:
!Return
.ENDIF ! DESERVE_DEFINED

