.IFNDEF PRINTERCTL.DEFINED
SET PRINTERCTL.DEFINED = 1

!========================================================================
!
! Because of limitations in the compiler the PI.DMPAPERSIZE constants
! have been compiled out.  To enable them, include 
! SET DEFINE.PAPER.SIZES = 1 in your code
!
! Because of limitations in the compiler the PI.DMDEFAULTSOURCE constants
! have been compiled out.  To enable them, include 
! SET DEFINE.PAPER.SOURCE = 1 in your code
!
!========================================================================

SET TWIPS.PER.INCH		= 1440.0

SET PtrGETSLAVEPRINTERNAME$	= "@FFE1@"	! Get slave printer name
SET PtrSETSLAVEPRINTERINFO$	= "@FFE2@"	! Set slave printer info
SET PtrGETSLAVEPRINTERINFO$	= "@FFE3@"	! Get slave printer info
SET PtrSETPRINTERINFO$		= "@FFE4@"	! Set printer info
SET PtrGETPRINTERINFO$		= "@FFE5@"	! Get printer info
SET PtrSETPARTPRINTER$		= "@FFED@"	! Set Windows partition printer
SET PtrGETPARTPRINTER$		= "@FFEC@"	! Get Windows partition printer

! FILE (LUN) CTL=xxxx
SET PTR.SIDEBANDDATA$		= "@0301@"	! Sideband data follows
SET PTR.GETFUNCRESULT$		= "@0302@"	! Stored function return value
SET PTR.GETPAGEINFO$		= "@0303@"	! -GetPageInfo(Item)
  SET PTR.PAGEINFO.PRINTABLESIZE = 0
  SET PTR.PAGEINFO.PHYSICALSIZE	 = 1
  SET PTR.PAGEINFO.PHYSICALOFFSET= 2
  SET PTR.PAGEINFO.LOGPIXELS	 = 3
SET PTR.GETBKMODE$		= "@0304@"	! -GetBkMode()
SET PTR.GETROP2$		= "@030B@"	! -GetROP2()
SET PTR.GETTEXTALIGN$		= "@0305@"	! -GetTextAlign()
SET PTR.GETBKCOLOR$		= "@0306@"	! -GetBkColor()
SET PTR.GETTEXTCOLOR$		= "@0307@"	! -GetTextColor()
SET PTR.GETFONTINFO$		= "@0308@"	! -GetFontInfo(nParam)
  SET PTR.FONT.HEIGHT		= 0
  SET PTR.FONT.EXTLEADING	= 1
  SET PTR.FONT.AVECHARWIDTH	= 2
  SET PTR.FONT.MAXCHARWIDTH	= 3
  SET PTR.FONT.WEIGHT		= 4
SET PTR.GETTEXTEXTENT$		= "@0309@"	! -GetTextExtent(lpszString)
SET PTR.SELECTSYSFONT$		= "@030A@"	! -SelectSystemFont(BYTE FontNum);

SET SB.SELECTFONT$		= "@01@"	! SelectFont(pLogFont)
SET SB.SELECTPEN$		= "@02@"	! SelectPen(nPenStyle, nWidth, crColor)
  SET PS.SOLID		= 0
  SET PS.DASH		= 1
  SET PS.DOT		= 2
  SET PS.DASHDOT	= 3
  SET PS.DASHDOTDOT	= 4
  SET PS.NULL		= 5
  SET PS.INSIDEFRAME	= 6

SET SB.SELECTSOLIDBRUSH$	= "@03@"	! SelectSolidBrush(crColor)
SET SB.SELECTHATCHBRUSH$	= "@04@"	! SelectHatchBrush(nStyle, crColor)
  SET HS.HORIZONTAL	= 0
  SET HS.VERTICAL	= 1
  SET HS.FDIAGONAL	= 2
  SET HS.BDIAGONAL	= 3
  SET HS.CROSS		= 4
  SET HS.DIAGCROSS	= 5

SET SB.SETTEXTCOLOR$		= "@05@"	! SetTextColor(crColor)
SET SB.SETBKCOLOR$		= "@06@"	! SetBkColor(crColor)
SET SB.SETBKMODE$		= "@07@"	! SetBkMode(nBkMode)
  SET BKM.TRANSPARENT	= 1
  SET BKM.OPAQUE	= 2

SET SB.MOVETO$			= "@08@"	! MoveTo(x, y)
SET SB.LINETO$			= "@09@"	! LineTo(x, y)
SET SB.ELLIPSE$			= "@0A@"	! Ellipse(x1, y1, x2, y2)
SET SB.RECTANGLE$		= "@0B@"	! Rectangle(x1, y1, x2, y2)
SET SB.ROUNDRECT$		= "@0C@"	! RoundRect(x1, y1, x2, y2, x3, y3)
SET SB.TEXTOUT$			= "@0D@"	! TextOut(x, y, szString)
SET SB.SETTEXTALIGN$		= "@0E@"	! SetTextAlign(nFlags)
  SET TA.NOUPDATECP	= 0
  SET TA.UPDATECP	= 1
  SET TA.LEFT		= 0
  SET TA.RIGHT		= 2
  SET TA.CENTER		= 6
  SET TA.TOP		= 0
  SET TA.BOTTOM		= 8
  SET TA.BASELINE	= 24

SET SB.SETPRINTERINFO$		= "@0F@"	! SetPrinterInfo(nIndex, nParam)
  SET PI.DMORIENTATION	= 0
    SET DMORIENT.PORTRAIT	= 1
    SET DMORIENT.LANDSCAPE	= 2
  SET PI.DMPAPERSIZE	= 1
.IFDEF DEFINE.PAPER.SIZES
    SET DMPAPER.LETTER               = 1  ! Letter 8 1/2 x 11 in
    SET DMPAPER.LETTERSMALL          = 2  ! Letter Small 8 1/2 x 11 in
    SET DMPAPER.TABLOID              = 3  ! Tabloid 11 x 17 in
    SET DMPAPER.LEDGER               = 4  ! Ledger 17 x 11 in
    SET DMPAPER.LEGAL                = 5  ! Legal 8 1/2 x 14 in
    SET DMPAPER.STATEMENT            = 6  ! Statement 5 1/2 x 8 1/2 in
    SET DMPAPER.EXECUTIVE            = 7  ! Executive 7 1/4 x 10 1/2 in
    SET DMPAPER.A3                   = 8  ! A3 297 x 420 mm
    SET DMPAPER.A4                   = 9  ! A4 210 x 297 mm
    SET DMPAPER.A4SMALL             = 10  ! A4 Small 210 x 297 mm
    SET DMPAPER.A5                  = 11  ! A5 148 x 210 mm
    SET DMPAPER.B4                  = 12  ! B4 (JIS) 250 x 354
    SET DMPAPER.B5                  = 13  ! B5 (JIS) 182 x 257 mm
    SET DMPAPER.FOLIO               = 14  ! Folio 8 1/2 x 13 in
    SET DMPAPER.QUARTO              = 15  ! Quarto 215 x 275 mm
    SET DMPAPER.10X14               = 16  ! 10x14 in
    SET DMPAPER.11X17               = 17  ! 11x17 in
    SET DMPAPER.NOTE                = 18  ! Note 8 1/2 x 11 in
    SET DMPAPER.ENV.9               = 19  ! Envelope #9 3 7/8 x 8 7/8
    SET DMPAPER.ENV.10              = 20  ! Envelope #10 4 1/8 x 9 1/2
    SET DMPAPER.ENV.11              = 21  ! Envelope #11 4 1/2 x 10 3/8
    SET DMPAPER.ENV.12              = 22  ! Envelope #12 4 \276 x 11
    SET DMPAPER.ENV.14              = 23  ! Envelope #14 5 x 11 1/2
    SET DMPAPER.CSHEET              = 24  ! C size sheet
    SET DMPAPER.DSHEET              = 25  ! D size sheet
    SET DMPAPER.ESHEET              = 26  ! E size sheet
    SET DMPAPER.ENV.DL              = 27  ! Envelope DL 110 x 220mm
    SET DMPAPER.ENV.C5              = 28  ! Envelope C5 162 x 229 mm
    SET DMPAPER.ENV.C3              = 29  ! Envelope C3  324 x 458 mm
    SET DMPAPER.ENV.C4              = 30  ! Envelope C4  229 x 324 mm
    SET DMPAPER.ENV.C6              = 31  ! Envelope C6  114 x 162 mm
    SET DMPAPER.ENV.C65             = 32  ! Envelope C65 114 x 229 mm
    SET DMPAPER.ENV.B4              = 33  ! Envelope B4  250 x 353 mm
    SET DMPAPER.ENV.B5              = 34  ! Envelope B5  176 x 250 mm
    SET DMPAPER.ENV.B6              = 35  ! Envelope B6  176 x 125 mm
    SET DMPAPER.ENV.ITALY           = 36  ! Envelope 110 x 230 mm
    SET DMPAPER.ENV.MONARCH         = 37  ! Envelope Monarch 3.875 x 7.5 in
    SET DMPAPER.ENV.PERSONAL        = 38  ! 6 3/4 Envelope 3 5/8 x 6 1/2 in
    SET DMPAPER.FANFOLD.US          = 39  ! US Std Fanfold 14 7/8 x 11 in
    SET DMPAPER.FANFOLD.STD.GERMAN  = 40  ! German Std Fanfold 8 1/2 x 12 in
    SET DMPAPER.FANFOLD.LGL.GERMAN  = 41  ! German Legal Fanfold 8 1/2 x 13 in
    SET DMPAPER.ISO.B4              = 42  ! B4 (ISO) 250 x 353 mm
    SET DMPAPER.JAPANESE.POSTCARD   = 43  ! Japanese Postcard 100 x 148 mm
    SET DMPAPER.9X11                = 44  ! 9 x 11 in
    SET DMPAPER.10X11               = 45  ! 10 x 11 in
    SET DMPAPER.15X11               = 46  ! 15 x 11 in
    SET DMPAPER.ENV.INVITE          = 47  ! Envelope Invite 220 x 220 mm
    SET DMPAPER.RESERVED.48         = 48  ! RESERVED--DO NOT USE
    SET DMPAPER.RESERVED.49         = 49  ! RESERVED--DO NOT USE
    SET DMPAPER.LETTER.EXTRA        = 50  ! Letter Extra 9 \275 x 12 in
    SET DMPAPER.LEGAL.EXTRA         = 51  ! Legal Extra 9 \275 x 15 in
    SET DMPAPER.TABLOID.EXTRA       = 52  ! Tabloid Extra 11.69 x 18 in
    SET DMPAPER.A4.EXTRA            = 53  ! A4 Extra 9.27 x 12.69 in
    SET DMPAPER.LETTER.TRANSVERSE   = 54  ! Letter Transverse 8 \275 x 11 in
    SET DMPAPER.A4.TRANSVERSE       = 55  ! A4 Transverse 210 x 297 mm
    SET DMPAPER.LETTER.EXTRA.TRANSVERSE = 56 ! Letter Extra Transverse 9\275 x 12 in
    SET DMPAPER.A.PLUS              = 57  ! SuperA/SuperA/A4 227 x 356 mm
    SET DMPAPER.B.PLUS              = 58  ! SuperB/SuperB/A3 305 x 487 mm
    SET DMPAPER.LETTER.PLUS         = 59  ! Letter Plus 8.5 x 12.69 in
    SET DMPAPER.A4.PLUS             = 60  ! A4 Plus 210 x 330 mm
    SET DMPAPER.A5.TRANSVERSE       = 61  ! A5 Transverse 148 x 210 mm
    SET DMPAPER.B5.TRANSVERSE       = 62  ! B5 (JIS) Transverse 182 x 257 mm
    SET DMPAPER.A3.EXTRA            = 63  ! A3 Extra 322 x 445 mm
    SET DMPAPER.A5.EXTRA            = 64  ! A5 Extra 174 x 235 mm
    SET DMPAPER.B5.EXTRA            = 65  ! B5 (ISO) Extra 201 x 276 mm
    SET DMPAPER.A2                  = 66  ! A2 420 x 594 mm
    SET DMPAPER.A3.TRANSVERSE       = 67  ! A3 Transverse 297 x 420 mm
    SET DMPAPER.A3.EXTRA.TRANSVERSE = 68  ! A3 Extra Transverse 322 x 445 mm
.ENDIF	! DEFINE.PAPER.SIZES

  SET PI.DMPAPERLENGTH	= 2
  SET PI.DMPAPERWIDTH	= 3
  SET PI.DMSCALE	= 4
  SET PI.DMPRINTQUALITY	= 5
    SET DMRES.DRAFT     = 65535	! -1
    SET DMRES.LOW       = 65534	! -2
    SET DMRES.MEDIUM    = 65533	! -3
    SET DMRES.HIGH      = 65532	! -4

  SET PI.DMCOLOR	= 6
    SET DMCOLOR.MONOCHROME = 1
    SET DMCOLOR.COLOR	   = 2

  SET PI.DMCOLLATE	= 7
    SET DMCOLLATE.FALSE	= 0
    SET DMCOLLATE.TRUE	= 1

  SET PI.DMDEFAULTSOURCE = 8
.IFDEF DEFINE.PAPER.SOURCE
    SET DMBIN.UPPER         = 1
    SET DMBIN.ONLYONE       = 1
    SET DMBIN.LOWER         = 2
    SET DMBIN.MIDDLE        = 3
    SET DMBIN.MANUAL        = 4
    SET DMBIN.ENVELOPE      = 5
    SET DMBIN.ENVMANUAL     = 6
    SET DMBIN.AUTO          = 7
    SET DMBIN.TRACTOR       = 8
    SET DMBIN.SMALLFMT      = 9
    SET DMBIN.LARGEFMT      = 10
    SET DMBIN.LARGECAPACITY = 11
    SET DMBIN.CASSETTE      = 14
    SET DMBIN.FORMSOURCE    = 15
.ENDIF	! DEFINE.PAPER.SOURCE
SET SB.DRAWTEXT$		= "@10@"	! DrawText(szString, -1, Rect, Format)
SET SB.DRAWBITMAP$		= "@11@"	! DrawBitmap(left, top, right, bottom, flags, filename)
SET SB.DRAWBITMAPIND$		= "@12@"	! DrawBitmapInd(left, top, right, bottom, flags, filename)
  SET BMR.FIT.TO.RECT		= 1
  SET BMR.CENTER.HZ.RECT	= 2
  SET BMR.CENTER.VT.RECT	= 4
  SET BMR.SCALE			= 8
  SET BMR.BEGIN.BMP.DATA	= 16

  SET PI.DMCOPIES = 9
	SET PI.DMDUPLEX = 10
		! duplex enable 
		SET DMDUP.SIMPLEX    = 1
		SET DMDUP.VERTICAL   = 2
		SET DMDUP.HORIZONTAL = 3

SET SB.SELECTSYSFONT$		= "@13@"	! -SelectSystemFont(BYTE FontNum);
SET SB.GETPAGEINFO$		= "@14@"	! -GetPageInfo(Item)
SET SB.GETFONTINFO$		= "@15@"	! -GetFontInfo(nParam)
SET SB.GETTEXTEXTENT$		= "@16@"	! -GetTextExtent(lpszString)
SET SB.GETBKMODE$		= "@17@"	! -GetBkMode()
SET SB.GETTEXTALIGN$		= "@18@"	! -GetTextAlign()
SET SB.GETBKCOLOR$		= "@19@"	! -GetBkColor()
SET SB.GETTEXTCOLOR$		= "@1A@"	! -GetTextColor()
SET SB.PUSHFONT$		= "@1B@"	! -PushFont()
SET SB.POPFONT$			= "@1C@"	! -PopFont()
SET SB.GETROP2$			= "@1D@"	! -GetROP2()
SET SB.SETROP2$			= "@1E@"	! -SetROP2(nROP2)
SET SB.LINESPACE$		= "@1F@"	! -SetLineSpacing(LinesPerInch)

.IFNDEF DRAW.TEXT.DEFINED
SET DRAW.TEXT.DEFINED = 1
!
! These constants are duplicated in #windows
! DrawText() Format Flags
SET	DT.TOP			= 0
SET	DT.LEFT			= 0
SET	DT.CENTER		= 1
SET	DT.RIGHT		= 2
SET	DT.VCENTER		= 4
SET	DT.BOTTOM		= 8
SET	DT.WORDBREAK		= 16
SET	DT.SINGLELINE		= 32
SET	DT.EXPANDTABS		= 64
SET	DT.TABSTOP		= 128
SET	DT.NOCLIP		= 256
SET	DT.EXTERNALLEADING	= 512
SET	DT.CALCRECT		= 1024
SET	DT.NOPREFIX		= 2048
SET	DT.INTERNAL		= 4096
SET	DT.EDITCONTROL		= 8192
SET	DT.PATH.ELLIPSIS	= 16384
SET	DT.END.ELLIPSIS		= 32768
SET	DT.MODIFYSTRING		= 65536
SET	DT.RTLREADING		= 131072
SET	DT.WORD.ELLIPSIS	= 262144
.ENDIF

.ENDIF	! PRINTERCTL.DEFINED

